<?php
/*
 * Oracle accessor based on Session Management for PHP3
 *
 * (C) Copyright 1998 Luis Francisco Gonzalez Hernandez
 *
 * $Id: db_oracle.inc,v 1.3 1998/11/12 14:09:06 sas Exp $
 *
 */ 

class DB_Sql {
  var $Debug    =  false;
  var $Home     = "/u01/app/oracle/product/8.0.4";
  var $Remote   =  1;

  var $Database = "";
  var $User     = "";
  var $Password = "";

  var $Link_ID    = 0;
  var $Query_ID  = 0;
  var $Record    = array();
  var $Row;

  var $Errno     = 0;
  var $Error     = "";

  function connect() {
      PutEnv("ORACLE_SID=$this->Database;");
      PutEnv("ORACLE_HOME=$this->Home;");
      if ( 0 == $this->Link_ID ) {
	  if($this->Debug) {
	      printf("<br>Connecting to $this->Database...<br>\n");
	  }
	  if($this->Remote) {
	    $this->Link_ID=ora_plogon
		("$this->User/$this->Password@$this->Database.world","");
	} else {
	    $this->Link_ID=ora_plogon("$this->User","$this->Password");
	}
	  if (!$this->Link_ID) {
	      $this->halt("Link-ID == false " .
			  "($this->Link_ID), ora_plogon failed");
	  } else {
	      ora_commiton($this->Link_ID);
	  }
	  if($this->Debug) {
	      printf("<br>Obtained the Link_ID: $this->Link_ID<br>\n");
	  }   
      }
  }
  
  function query($Query_String) {
      $this->connect();
      
      $this->Query_ID= ora_open($this->Link_ID);
      if(!ora_parse($this->Query_ID,$Query_String)) {
	  $this->Errno=ora_errorcode($this->Query_ID);
	  $this->Error=ora_error($this->Query_ID);
      } else if(ora_exec($this->Query_ID)) {
	  $this->Errno=ora_errorcode($this->Query_ID);
	  $this->Error=ora_error($this->Query_ID);
      }

      $this->Row=0;

      if($this->Debug) {
	  printf("Debug: query = %s<br>\n", $Query_String);
	  printf("<br>Debug: Query_ID: %d<br>\n", $this->Query_ID);
      }
      
      if(!$this->Query_ID) {
	  $this->halt("Invalid SQL: ".$Query_String);
      }
      
      return $this->Query_ID;
  }
  
  function next_record() {
      if(0 == ora_fetch($this->Query_ID)) {
          if ($this->Debug) {
            printf("<br>ID: %d,Rows: %d<br>\n",
              $this->Query_ID,$this->num_rows());
          }
	  $this->Row	+=1;
	  
	  $errno=ora_errorcode($this->Query_ID);
	  if(1403 == $errno) { # 1043 means no more records found
	      $this->Errno=0;
	      $this->Error="";
	      $this->disconnect();
	      $stat=0;
	  } else {
	      $this->Error=ora_error($this->Query_ID);
	      $this->Errno=$errno;
	      if($this->Debug) {
		  printf("<br>%d Error: %s",
			 $this->Errno,
			 $this->Error);
	      }
	      $stat=0;
	  }
      } else {
	  for($ix=0;$ix<ora_numcols($this->Query_ID);$ix++) {
	      $col=strtolower(ora_columnname($this->Query_ID,$ix));
	      $value=ora_getcolumn($this->Query_ID,$ix);
	      $this->Record[ "$col" ] = $value;
	      echo"<b>[$col]</b>: $value <br>\n";
	  }
	  $stat=1;
      }

  return $stat;
  }

  function seek($pos) {
      $this->Row=$pos;
  }

  function metadata($table) {
      $count = 0;
      $id    = 0;
      $res   = array();
      
      $this->connect();    
      
      if( 0 != ($id  = ora_open($this->Link_ID) ) ) {
	  if( 0 != ora_parse($id,"describe $table") ) {
	      if( 0 != ora_fetch($id) ) {
		  
		  $count=ora_numcols($id);
		  for($i=0; $i<$count; $i++) {
		      $rec[$i]["table"] =  $table;
		      $rec[$i]["name"]  =  ora_columnname($id,$ix);
		      $rec[$i]["type"]  =  ora_columnntype($id,$ix);
		      $rec[$i]["len"]   =  "";
		      $rec[$i]["flags"] =  "";
		  }
	      }
	  }
      }
      
      $this->disconnect();
      return $res;
  }

  function affected_rows() {
    return $this->num_rows();
  }

  function num_rows() {
    return ora_numrows($this->Query_ID);
  }

  function num_fields() {
      return ora_numcols($this->Query_ID);
  }

  function nf() {
    return $this->num_rows();
  }

  function np() {
    print $this->num_rows();
  }

  function f($Name) {
    return $this->Record[$Name];
  }

  function p($Name) {
    print $this->Record[$Name];
  }

  function disconnect() {
      if($this->Debug) {
	  printf("Disconnecting...<br>\n");
      }
      ora_close($this->Query_ID);
  }
  
  function halt($msg) {
    printf("</td></tr></table><b>Database error:</b> %s<br>\n", $msg);
    printf("<b>ORACLE Error</b>: %s (%s)<br>\n",
      $this->Errno,
      $this->Error);
    die("Session halted.");
  }
}
?>
