<?php
/*
 * Session Management for PHP3
 *
 * (C) Copyright 1998 SH Online Dienst GmbH
 *                    Boris Erdmann, Kristian Koehntopp
 *
 * $Id: local.inc,v 1.8 1998/11/17 13:33:22 sas Exp $
 *
 */ 

class DB_Poe extends DB_Sql {
  var $Host     = "localhost";             ## 
  var $Database = "poe_sessions";          ## 
  var $User     = "kris";                  ## 
  var $Password = "";                      ## 
}

class Poe_Session extends Session {
  var $classname = "Poe_Session";

  var $cookiename     = "";                ## defaults to classname
  var $magic          = "Hocuspocus";      ## ID seed
  var $mode           = "cookie";          ## We propagate session IDs with cookies
  var $fallback_mode  = "get";
  var $lifetime       = 0;                 ## 0 = do session cookies, else minutes
 
  var $database_class = "DB_Poe";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.

  var $gc_probability = 5;  
}

class Poe_User extends User {
  var $classname = "Poe_User";

  var $magic          = "Abracadabra";     ## ID seed
  var $database_class = "DB_Poe";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.
}

class Poe_Auth extends Auth {
  var $classname      = "Poe_Auth";

  var $lifetime       =  15;

  var $database_class = "DB_Poe";
  var $database_table = "auth_user";
  
  function auth_loginform() {
    global $sess;
    include("loginform.ihtml");
  }
  
  function auth_validatelogin() {
    global $username, $password;

    $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    
    $uid = false;

    $this->db->query(sprintf("select uid, perms
                                     from %s
                                    where username = '%s'
                                      and password = '%s'",

                          $this->database_table,
                          addslashes($username),
                          addslashes($password)));

    while($this->db->next_record()) {
      $uid = $this->db->f("uid");
      $this->auth["perm"] = $this->db->f("perms");
    }
    return $uid;
  }
}

class Poe_Default_Auth extends Poe_Auth {
  var $classname = "Poe_Default_Auth";
  
  var $nobody    = true;
}

class Poe_Challenge_Auth extends Auth {
  var $classname      = "Poe_Challenge_Auth";

  var $lifetime       =  1;

  var $magic          = "Simsalabim";  ## Challenge seed
  var $database_class = "DB_Poe";
  var $database_table = "auth_user";

  function auth_loginform() {
    global $sess;
    global $challenge;
    
    $challenge = md5(uniqid($this->magic));
    $sess->register("challenge");
    
    include("crloginform.ihtml");
  }
  
  function auth_validatelogin() {
    global $username, $password, $challenge, $response;

    $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    $this->db->query(sprintf("select uid,perms,password ".
				"from %s where username = '%s'",
                          $this->database_table,
                          addslashes($username)));

    while($this->db->next_record()) {
      $uid   = $this->db->f("uid");
      $perm  = $this->db->f("perms");
      $pass  = $this->db->f("password");
    }
    $exspected_response = md5("$username:$pass:$challenge");

    ## True when JS is disabled
    if ($response == "") {
      if ($password != $pass) {
        return false;
      } else {
        $this->auth["perm"] = $perm;
        return $uid;
      }
    }
    
    ## Response is set, JS is enabled
    if ($exspected_response != $response) {
      return false;
    } else {
      $this->auth["perm"] = $perm;
      return $uid;
    }
  }
}

class Poe_Perm extends Perm {
  var $classname = "Poe_Perm";
  
  var $permissions = array(
                            "user"       => 1,
                            "author"     => 2,
                            "editor"     => 4,
                            "supervisor" => 8,
                            "admin"      => 16
                          );

  function perm_invalid($does_have, $must_have) {
    global $perm, $auth, $sess;
    
    include("perminvalid.ihtml");
  }
}
?>
