<?php
/*
 * Session Management for PHP3
 *
 * (C) Copyright 1998 SH Online Dienst GmbH
 *                    Boris Erdmann, Kristian Koehntopp
 *
 * $Id: user.inc,v 1.2 1998/09/16 18:31:58 kk Exp $
 *
 */ 

class User extends Session {
  var $classname = "User";         ## Needed for object serialization.

  var $database_class = "DB_SAM";     ## Which database to connect...
  var $database_table = "sessions";   ## Table to use for session data.

  var $database_lock_semaphore = "";  ## if not an empty string: use this
                                      ## semaphore string to lock db access
 
  ##
  ## End of parameters.
  ##

  var $name;                          ## Session name
  var $id;                            ## Unique Session ID

  var $db;                            ## Database Object
  var $pt = array();                  ## This Array contains the registered things

  ## get_id():
  ##
  ## Propagate the session id according to mode and lifetime.
  ## Will create a new id if necessary. To take over abandoned sessions,
  ## one may provide the new session id as a parameter (not recommended).
  function get_id($id = "") {
    $this->id = $id;
  }
  
  ## put_id():
  ## 
  ## Stop using the current session id (unset cookie, ...) and
  ## abandon a session.
  function put_id() {
    ;
  }

  function get_lock() {
    if ( "" != $this->database_lock_semaphore ) {
      while ( ! $this->db->query("select get_lock('%s')", $this->database_lock_semaphore) ) {
        $t = 1 + time(); while ( $t > time() ) { ; }
      }
    }
  }

  function release_lock() {
    if ( "" != $this->database_lock_semaphore ) {
      $this->db->query("select release_lock('%s')", $this->database_lock_semaphore);
    }
  }

  ##
  ## Initialization
  ##

  function start($sid = "") {
    $this->get_id($sid);
 
    eval("\$this->db = new ".$this->database_class.";");
 
    $this->thaw();
//  No gc() on user data, ever.
//    if ((rand()%100) < $this->gc_probability) {
//      $this->gc();
//    }
  }
}
?>
